	
#define GLUE(a, b)  a##b
#define sbi(var, bit) (var|=1<<bit)//set
#define cbi(var, bit) (var&=~(1<<bit))//clear
#define tbi(var, bit) (var^=1<<bit)//toggle
#define gbi(var, bit) (var>>bit&1)//get
#define wait  _delay_ms(1000)
#define wait10  {_delay_ms(3333);_delay_ms(3333);_delay_ms(3333);}
#define u8  uint8_t
#define u16 uint16_t
#define u32 uint32_t
#define v volatile

#if AVR	
#define PORT(x)    			GLUE(PORT, x)
#define PIN(x)    			GLUE(PIN, x)
#define DDR(x)    			GLUE(DDR, x)
#define pinSET(x,y) 		PORT(x) |=(1<<y)
#define pinCLR(x,y) 		PORT(x)&=~(1<<y)
#define pinTOG(x,y) 		PORT(x)^=(1<<y)
#define pinDIRin(x,y) 		DDR(x)&=~(1<<y)
#define pinDIRout(x,y) 		DDR(x)|=(1<<y)
#define pinVAL(x,y) 		(PIN(x)&(1<<y))
//  #define MINimal(x,y)  ((x<y) ? x : y)
#define pinPULLUP(x,y,z) 	(z)?(PORT(x)|=(1<<y)):(PORT(x)&=~(1<<y))//0_no 1_up 
#define ux  uint8_t
//_delay_us
#include <util/delay.h>
#endif

#if stm
#define GPIO(x)    GLUE(GPIO, x)
#define RCC_APB2Periph_GPIO(x)    GLUE(RCC_APB2Periph_GPIO, x)
//		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIO(x)  , ENABLE);
#define PIN(x)    GLUE(GPIO_PIN_,x)
#define pinSET(x,y) GPIO(x)->ODR |=(1<<y)
#define pinCLR(x,y) GPIO(x)->ODR &=~(1<<y)
GPIO_InitTypeDef GPIO_InitStructure;
#define pinDIRout(x,y) { \
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; \
	  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_Out_PP; \
	  GPIO_InitStructure.GPIO_Pin   = 1<<y ; \
	  GPIO_Init(GPIO(x), &GPIO_InitStructure);}

#define pinDIRin(x,y) { \
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; \
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; \
	GPIO_InitStructure.GPIO_Pin = 1<<y; \
	GPIO_Init(GPIO(x), &GPIO_InitStructure);}

/*0_no 1_up 2_down*/ 
#define pinPULLUP(x,y,z) { \
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; \
	  GPIO_InitStructure.GPIO_Mode  = z; \
	  GPIO_InitStructure.GPIO_Pin   = 1<<y ; \
	  GPIO_Init(GPIO(x), &GPIO_InitStructure);}




#define pinVAL(x,y) (GPIO(x)->IDR)&(1<<(y))


#define pinTYPE(x,y) GPIO(x)->OTYPER&=~(3<<(y*2))//
#endif
//----------------------------------------
#define led1_tog 	pinTOG(LED1_port,LED1_pin)
#define led1_on   	pinSET(LED1_port,LED1_pin)
#define led1_off   	pinCLR(LED1_port,LED1_pin)
#define led1_blink {led1_tog;_delay_ms(300);led1_tog;_delay_ms(300);led1_tog;\
		_delay_ms(300);led1_tog;_delay_ms(300);}
#define led1_init 	pinDIRout(LED1_port,LED1_pin);led1_blink;

#define led2_tog 	pinTOG(LED2_port,LED2_pin)
#define led2_on   	pinSET(LED2_port,LED2_pin)
#define led2_off   	pinCLR(LED2_port,LED2_pin)
#define led2_blink {led2_tog;_delay_ms(300);led2_tog;_delay_ms(300);led2_tog;\
		_delay_ms(300);led2_tog;_delay_ms(300);}
#define led2_init 	pinDIRout(LED2_port,LED2_pin);led2_blink;
//pinout
#define led_on  led1_on 
#define led_off led1_off


#define true 1
#define false 0

void nothing(void){;}


#define HOUR 	hou
#define MINUTE 	min
#define SEC 	sec



